public class AtomicLong extends Thread {
   static volatile long val;
   static int count = 10000000;
   long key;
   AtomicLong(int k) {
      long temp = k;
      key = (temp<< 32) | temp;
   }

   public void run() {
      for(int i = 0; i < count; i++) {
         long temp = val;
         long temp1 = temp>>>32;
         long temp2 = temp<<32;
         temp2 = temp2>>>32;
         if (temp1 != temp2) {
            System.out.println("Saw: " + Long.toHexString(temp));
            System.out.println(" temp1 is: " + Long.toHexString(temp1));
            System.out.println(" temp2 is: " + Long.toHexString(temp2));
            System.exit(1);
         }
         val = key;
      }
   }

   public static void main(String args[]) {
      for(int t = 1; t < 10; t++)
         new AtomicLong(t).start();
   }
}